;                       FindAll   Find all files containing specified text

; This program allows you to search files within a folder and all sub folders for text strings

; This program will only search the first 4GB of a file.

.686
.model Flat, Stdcall
option Casemap :None   ; case sensitive
.xmm
.nolist
include Windows.inc

uselib MACRO libname:req
    include    libname.inc
    includelib libname.lib
endm

uselib user32
uselib kernel32
uselib shell32
uselib comctl32
uselib comdlg32
uselib gdi32
uselib shlwapi
uselib ole32
;uselib masm32	; for debug
;uselib debug	; for debug

.listall

soff Macro QuotedText:Vararg	; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

msg Macro qtext:VARARG	; quickie messages to the user
local result
pusha
    quote SUBSTR <qtext>,1,1
    IFIDN quote , <">  ;; if this is a quoted string
   		inv MessageBox,hWin,soff(qtext),addr ProgName,0
   	else
		result=opattr(qtext)
		if result eq 48	;; a register
			inv MessageBox,hWin,qtext,addr ProgName,0
		else
			inv MessageBox,hWin,addr qtext,addr ProgName,0
		endif
	endif   
popa
endm
m2m MACRO M1:req, M2:req
	push M2
	pop  M1
ENDM

;  for debugging
;prtd MACRO argf	; debugging print integer
;pusha
;ifndef prtdBuff
;.data?
;prtdBuff db 12 dup (?)
;.code
;endif
;mov eax,argf
;mov edi,offset prtdBuff
;call dwtoax2
;inv MessageBox,hWin,addr prtdBuff,addr ProgName,0
;popa
;EndM

inv equ INVOKE

; dialog controls.
Dia               equ 101 
;edits 
StringsFileFrame  equ 5001
StringsFile       equ 1101
StartFolderFrame  equ 5002
StartFolder    	  equ 1102
OutputFile        equ 1103
EText1            equ 1201
EText2            equ 1202
;combobox
FileTypes         equ 1301
;checkboxes  
PrintFileName     equ 1701
CaseSensitive     equ 1702
NumberLines       equ 1703
;buttons
ReadStrings       equ 2001
SaveStrings       equ 2002
Search            equ 2003
EditOutput        equ 2005
EditFileSpecs     equ 2006
StringsFileBrowse equ 2101
StartFolderBrowse equ 2102

; changable statics
DoingFile         equ 4000
FilesInPath		  equ 4001
FilesSearched	  equ 4002
FilesFound		  equ 4003
LinesFound		  equ 4004
ET				  equ 4005
UnreadableFiles   equ 4006
FileReadErrors    equ 4007
Rereads           equ 4008
; unchangeable statics
StringsFileLabel  equ 1001
FindLineLabel     equ 1002
Rich2Label        equ 1003
StartFolderLabel  equ 1004
OutputFileLabel   equ 1005
FileTypesLabel    equ 1006
DoingFileLabel    equ 1010
ETLabel           equ 1015
UnreadableLabel   equ 1016
ReadErrorsLabel   equ 1017
ReReadsLabel      equ 1018
FilesInPathLabel  equ 1011
SearchedLabel     equ 1012
FilesFoundLabel   equ 1013
LinesFoundLabel   equ 1014
.data
; handles for the controls will be kept here
StartOfHandles equ $
hStringsFile       dd StringsFile      
hStartFolder       dd StartFolder     
hOutputFile        dd OutputFile         
hEText1            dd EText1             
hEText2            dd EText2             
hFileTypes         dd FileTypes          
hPrintFileName     dd PrintFileName       
hCaseSensitive     dd CaseSensitive      
hNumberLines       dd NumberLines        
hReadStrings       dd ReadStrings             
hSaveStrings       dd SaveStrings             
hSearch            dd Search             
hEditOutput        dd EditOutput
hEditFileSpecs	   dd EditFileSpecs
hStringsFileBrowse dd StringsFileBrowse
hStartFolderBrowse dd StartFolderBrowse         
LastUser equ $	; end of group to be disabled while searching
hDoingFile         dd DoingFile          
hFilesInPath	   dd FilesInPath
hFilesSearched	   dd FilesSearched
hFilesFound		   dd FilesFound
hLinesFound		   dd LinesFound
hET				   dd ET
hUnreadableFiles   dd UnreadableFiles
hFileReadErrors    dd FileReadErrors
hRereads           dd Rereads

hStartFolderFrame  dd StartFolderFrame
hStringsFileFrame  dd StringsFileFrame
hStringsFileLabel  dd StringsFileLabel
hFindLineLabel     dd FindLineLabel   
hRich2Label        dd Rich2Label      
hStartFolderLabel  dd StartFolderLabel
hOutputFileLabel   dd OutputFileLabel 
hFileTypesLabel    dd FileTypesLabel  
hDoingFileLabel    dd DoingFileLabel  
hETLabel           dd ETLabel         
hUnreadableLabel   dd UnreadableLabel 
hReadErrorsLabel   dd ReadErrorsLabel 
hReReadsLabel      dd ReReadsLabel    
hFilesInPathLabel  dd FilesInPathLabel
hSearchedLabel     dd SearchedLabel   
hFilesFoundLabel   dd FilesFoundLabel 
hLinesFoundLabel   dd LinesFoundLabel 
LastHandle  equ $
NumberOfControls = (LastHandle-StartOfHandles)/4

;Code bit   action
; L    0 000001b set left based upon dia width
; T    1 000010b set top  based upon dia height
; T2   2 000100b set top based upon 1/2 dia height e.g. rich edits, rich2 label
; H2   3 001000b set Height based upon 1/2 dia height e.g. rich edits
; W    4 010000b set width based upon dia width
; L2   5 100000b set left based upon 1/2 dia width  eg. search, edit buttons, bottom info

; note**** bits must be in same order as handles above
 StartOfBitCodes equ $
 db 010000b ;W     ;StringsFile           
 db 010010b ;TW    ;StartFolder     
 db 010010b ;TW    ;OutputFile         
 db 011000b ;WH2   ;EText1             
 db 011100b ;WT2H2 ;EText2             
 db 010010b ;TW    ;FileTypes          
 db 000001b ;L     ;PrintFileName       
 db 000001b ;L     ;CaseSensitive      
 db 000001b ;L     ;NumberLines        
 db 000001b ;L     ;ReadStrings             
 db 000001b ;L     ;SaveStrings             
 db 100010b ;TL2   ;Search             
 db 100010b ;TL2   ;EditOutput
 db 000011b ;TL    ;EditFileSpecs
 db 000001b ;L     ;StringsFileBrowse
 db 000011b ;TL    ;StartFolderBrowse         
    
 db 010010b ;TW    ;DoingFile          
 db 100010b ;TL2   ;FilesInPath
 db 100010b ;TL2   ;FilesSearched
 db 100010b ;TL2   ;FilesFound
 db 100010b ;TL2   ;LinesFound
 db 100010b ;TL2   ;ET
 db 100010b ;TL2   ;UnreadableFiles
 db 100010b ;TL2   ;FileReadErrors
 db 100010b ;TL2   ;Rereads
    
 db 010010b ;TLW   ;StartFolderFrame
 db 010000b ;W     ;StringsFileFrame
 db 000000b ;0     ;StringsFileLabel
 db 000000b ;0     ;FindLineLabel   
 db 000100b ;T2    ;Rich2Label      
 db 000010b ;T     ;StartFolderLabel
 db 000010b ;T     ;OutputFileLabel 
 db 000010b ;T     ;FileTypesLabel  
 db 000010b ;T     ;DoingFileLabel  
 db 100010b ;TL2   ;ETLabel         
 db 100010b ;TL2   ;UnreadableLabel 
 db 100010b ;TL2   ;ReadErrorsLabel 
 db 100010b ;TL2   ;ReReadsLabel    
 db 100010b ;TL2   ;FilesInPathLabel
 db 100010b ;TL2   ;SearchedLabel   
 db 100010b ;TL2   ;FilesFoundLabel 
 db 100010b ;TL2   ;LinesFoundLabel 
LastBitCode  equ $


  
crlf equ 0dh,0ah
cr	 equ 0dh
lf	 equ 0ah

ProgName    db "Find All",0
AboutMsg    db crlf,"FindAll version 1.0 by Jim Giordano",0

wPosition	db	'[[Fa]]',0	; tag for old window position in ini file
tmpPosition db  '[[Tmp]]',0	; tab for startup positions
LineEnd		db	crlf,0

align 4
NT          dd 0           ; NT flag, assume not NT

RunningFlag dd 0  ; 1=am running flag. Set to zero when exit selected
Started     dd 0  ; Program made it through load and is executing
StopSearch	dd 0
DoingFSEdit dd 0  ; flag that we are editing file specs

; setup various tables and buffers

BufSize  		equ 65536*8	; size of each input buffer.  Will double buffer.
MaxSearchString equ 1022	; maximum length of a search string. Keep a multiple of dword.
MaxLevel 		equ 128		; maximum of 128 folders deep c:\a\b\c\d\  etc. up to 260 chars for path
MaxBack         equ 65536   ; size of back buffers
OutputBufSize   equ 65536	; output buffer size
maxlinesize     equ 1024    ; do not exceed MaxBack-2048.  Also OutputBuf must be many times larger.

.data?   ; start of uninitialized data.  Keep on even boundaries for better access
align 4

   ;  Buffers that will be requested from the heap
;		   db 64 dup (?)	  ; enough to align at even 64 byte boundary
;DataBack  db MaxBack dup (?) ; Back buffer of previously read data for printing or not search or overlap
;DataIn	   db BufSize dup (?) ; Current data
;DataU     db BufSize dup (?) ; Current data converted to upper case
;          db 64 dup (?)	  ; guard bytes, enough to align buffers at even 64 byte boundary 

DataBack  dd ?	; where the offsets to the buffers will be stored.
DataIn    dd ?
DataU	  dd ?

STableDat	dd 256 dup (?)	; addresses of start of search strings, one for each character
NTableDat 	dd 256 dup (?)	; addresses of start of discard strings
CaseTables	db 512 dup (?)	; conversion lower to upper case.  First 256 is conversion. Last 256 is no change.
;UCaseTable db 65536*2 dup (?)  ; will be requested from heap
UCaseTable  dd ?	; heap address of UCaseTable
OutputBuf	dd ?    ;db OutputBufSize dup (?)	; will be requested from heap
OutputBufEnd dd ?	; will be computed later 
OutputPtr   dd ? 	; pointer into output buffer
ResultFile  dd 512 dup (?)
Folders	    db MaxLevel*8 dup (?)  ;MaxLevel*8  (2 dwords each = 8 bytes)
.data
align 4
CaseUpper	dd offset CaseTables ; offset to table conversion from lower to upper case
STable      dd offset STableDat  ; offset to array of search strings
NTable		dd offset NTableDat  ; offset to array of discard strings

HeapHandle  dd 0  ; Handle to process Heap for extra memory
HeapSearch 	dd 0  ; heap for Search routine  ;start of a heap block
HeapData	dd 0  ; heap for reading files, etc. for search
HeapFSpecs  dd 0  ; heap for file specs wanted
HeapErrorMessage db "error allocating heap",0

.data?
align 4
hWin        dd ?  ; dialog handle
hRich		dd ?  ; for rich edit library
hFont  		dd ?  ; for rich edits. To be able to show trailing blanks.
OldEditWnd  dd ?  ; old edit proc
PreBuff     db 4 dup (?)    ; for making millisecs into seconds
Buff        db 512 dup (?)  ; short term temp buffer
Buff2		db 512 dup (?)  ; more short term temp buffer
tmp			dd ?			; short term temp pointers
tmp2		dd ?			
tmp3		dd ?
junk		dd ?
NewWidth	dd ?	; width of dialog client area from WM_SIZE
NewHeight	dd ?	; height   "

cf		CHARFORMAT2 <?>		; for rich edit
SHSave 	RECT 		<?>		; old saved position
OFSave  RECT 		<?>		; old saved position for open file dialog

FileTemp  dd ?      ; various scratch file info

FileN db 260 dup (?) 	; the current search path

; Vars used for resizing
WinPlace  WINDOWPLACEMENT <?>	; size and position of window for next time.  Saved in ini file.

Loca Struc
   L dd ? ; Left
   T dd ? ; Top
   W dd ? ; Width
   H dd ? ; Height
Loca Ends 

Ctrls    dd ?  ; heap address of control information
LastCtrl dd ?  ; one past last address used
OrigLoc Loca <?>  ; original position and size of dialog

; buffers and handles, etc. for file data reading and writing
Closed equ INVALID_HANDLE_VALUE		; flag we will use to indicate that file is closed (stored in handle)

hInst dd ?
.code

Program:

    inv InitCommonControls
	inv GetProcessHeap
	mov HeapHandle,eax
    inv LoadLibrary,soff("riched20.dll")
    mov hRich,eax    
    inv GetModuleHandle,NULL
    mov hInst,eax
	DlgProc Proto :DWord,:DWord,:DWord,:DWord
    inv DialogBoxParam,eax,101,0,ADDR DlgProc,0
    inv  FreeLibrary, hRich
    xor eax,eax
    inv ExitProcess,eax

; --------------------------------------------------------------------------------------------------
; --------------------------------------------------------------------------------------------------

DlgProc proc uses edi esi ebx hWnd:DWord,uMsg:DWord,wParam:DWord,lParam:DWord
	.if uMsg == WM_COMMAND
        ; loword of wparam = menu item, control, or accelerator identifier
        ; hiword of wparam=notification code if from a control, 1 if from accelerator, 0 if from menu
        ; lparam = control sending the message, otherwise 0
        ; if your menu and control ids are unique, no need to see what kind it is.

        mov eax,wParam  ; identifier of the control, or accelerator
        mov edx,eax     ; check hiword (notification code)
        shr edx,16
        .if lParam!=0   ; menu item or accelerator if zero, else a control
            .if ax>=2000 ; is it a button?  All button ids are 2001 or greater
                .if (dx==BN_CLICKED) || (dx==BN_DBLCLK) ; was a button clicked?
                    .if ax==ReadStrings
                        call ReadStringsClick
                    .elseif ax==SaveStrings
                        call SaveStringsClick
                    .elseif ax==Search
                    	.if DoingFSEdit==1
                    		; multi use button, is currently editing file specs
							; this is now save
							call SaveFileSpecEdit                    		
	                	.elseif StopSearch == 0 	; start the search
							push offset SearchClick
							pop ebx
							inv CreateThread,0,0,ebx,0,0,0
							inv CloseHandle,eax  ;saving handle not usually needed
	             		.elseif StopSearch==1
							inv EnableWindow,hSearch,FALSE
							mov StopSearch,2  ;advise thread to terminate
	             		.endif
                    .elseif ax==EditOutput
                    	.if DoingFSEdit==1
                    		; multi use button, is currently editing file specs
                    		; this is now cancel
                    		call CancelFileSpecEdit
                    	.else
                        	call EditFile
                        .endif
                    .elseif ax==StringsFileBrowse
                    	mov ecx,hStringsFile
                    	call GetFileName
					.elseif ax==StartFolderBrowse
						mov ecx,hStartFolder
						call GetFolder
					.elseif ax==EditFileSpecs
						call SetupFileSpecEdit
                    .endif
                    inv SendMessage, lParam, BM_SETSTYLE, BS_PUSHBUTTON, TRUE  ; make button look normal
                    ;inv SetFocus,hDummyT    ; get the focus off the button to make it look really regular
				.endif
            .elseif ax==FileTypes	; the combo box
            	.if dx==CBN_KILLFOCUS
					inv PostMessage,hWin,WM_USER+1,0,0  ; let me know combo changed
            	.endif
            .endif
        .endif
    .elseif uMsg==WM_USER+1	; if combobox text changes, need to add trailing blank
		inv SendMessage,hFileTypes,WM_GETTEXT,100,addr Buff
		add eax,offset Buff
		.if byte ptr[eax-1] != " "	; add a trailing blank to fix problem of combo box
			mov [eax],word ptr 0020h  ; highlighting entry when width is changed in WM_SIZE event
			inv SendMessage,hFileTypes,WM_SETTEXT,0,addr Buff
		.endif
    .elseif uMsg== WM_INITDIALOG
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
        call FormLoad
        jc	WrapUpAll	;error, just quit        
    .elseif uMsg == WM_CLOSE
        jmp WrapUpAll
    .elseif uMsg == WM_SIZE
    	.if wParam!=SIZE_MINIMIZED
			movzx eax,word ptr lParam
			mov NewWidth,eax
			movzx eax,word ptr [lParam+2]
			mov NewHeight,eax
	        call FormResize
        .endif
    .endif
	xor eax,eax		; return false, tell window to process this message
	jmp DlgProcRet
WrapUpAll:
    call FormUnload
EndIt:
    inv EndDialog,hWin,0
DlgProcRet:
	ret
DlgProc Endp

EditWndProc Proc hEdit:DWord,uMsg:DWord,wParam:DWord,lParam:DWord
	;traps messages richedit controls
	.If uMsg == WM_GETDLGCODE
    	MOV eax,DLGC_WANTALLKEYS    ; need this to get tab and other special keys
		jmp EditWndRet
	.Endif
	inv CallWindowProc,OldEditWnd,hEdit,uMsg,wParam,lParam
EditWndRet:
	RET
EditWndProc EndP


GetErrDescriptionx proc Routine:DWORD ; from masm lib, but fixed error and added routine name
LOCAL hLocal:DWORD, Bufferx[256]:BYTE
.data
ErrMsgTmpl 	db '%s: Error Code %i',13,10,'%s',0
Unknown 	db 'UnKnown Error',0
.code
	pusha	; not time critical, use less bytes
    inv GetLastError
    mov edi,eax
    inv FormatMessage,FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,
            0,edi,0,        ; GetItFromSystem, ErrNum, Default language
            addr hLocal,0,0 ; address of string from system, any size, no arguments
    mov ebx,offset Unknown
    .if eax!=0
    	inv LocalLock,hLocal
    	mov ebx,eax
    .endif
    inv wsprintf,addr Bufferx,offset ErrMsgTmpl,Routine,edi,ebx
    inv MessageBox,0,addr Bufferx,0,0
    .if ebx!=offset Unknown
    	inv LocalFree,hLocal
	.endif
	popa
    ret
GetErrDescriptionx endp

ShowHeapError proc routinename:DWORD  ; rname is name of routine that had the error
	inv GetErrDescriptionx,routinename
	msg HeapErrorMessage
	ret
ShowHeapError EndP
FreeHeap proc heapmem:dword  ; free up memory from HeapAlloc
	mov	ecx,heapmem
	mov	ecx,[ecx]
	or	ecx,ecx
	jz	fret
	inv	HeapFree,HeapHandle,0,ecx
	.if eax==0
		inv GetErrDescriptionx,soff("FreeHeap")
	.endif	
	mov ecx,heapmem
	mov dword ptr [ecx],0
fret:
	ret
FreeHeap EndP

.data?
IniName db 260 dup (?)

.data
PrintFileNamesOption db "PrintFileNames",0
CaseSensitiveOption  db "CaseSensitive",0
NumberLinesOption    db "NumberLines",0
Options              db "Options",0
Position             db "Position",0
FileTypesOption      db "File Types",0
FileSpec             db "FileSpec",0
One  db "1",0
Zero db "0",0
.code
SetOption proc  ; ecx=offset to key string, ebx=handle to checkbox
	inv GetPrivateProfileInt,addr Options,ecx,1,addr IniName
	inv SendMessage,ebx,BM_SETCHECK,eax,0
	ret
SetOption EndP
SaveOption proc	; ecx=handle to checkbox, ebx=offset to key string
	inv	SendMessage,ecx,BM_GETCHECK,0,0
	mov edx,offset One
	.if eax==0
		inc edx
		inc edx
	.endif
	inv WritePrivateProfileString,addr Options,ebx,edx,addr IniName
	ret
SaveOption EndP

SetupFileTypesCombo proc  ; get the file types the user likes from his ini file
	pusha	; not time critical
	mov esi,OutputBuf
	inv GetPrivateProfileSection,addr FileTypesOption,esi,OutputBufSize,addr IniName
	.if eax==0
	  mov esi,soff("*.*",0,"*.asm *.inc *.rc",0,0)  ; defaults
	.endif
	inv SendMessage,hFileTypes,CB_RESETCONTENT,0,0

	.repeat
		inv SendMessage,hFileTypes,CB_ADDSTRING,0,esi
		.repeat		; skip to next item
			lodsb
		.until al==0
		mov al,byte ptr [esi]	; double zbt means end
	.until al==0
	mov tmp,0
	inv GetPrivateProfileString,addr Options,addr FileSpec,addr tmp,addr Buff,500,addr IniName
	.if byte ptr Buff == 0 
		inv SendMessage,hFileTypes,CB_SETCURSEL,0,0
	.else
		inv SendMessage,hFileTypes,WM_SETTEXT,0,addr Buff
	.endif
	inv PostMessage,hWin,WM_USER+1,0,0  ; let me know combo changed
	popa
	ret
SetupFileTypesCombo EndP

FormLoad  proc  ; do setup here (setup fonts, get handles, etc)
	pusha	; uses most everything and is not time critical
	mov RunningFlag,1
	; get all the handles of the controls
	call GetAllPostionsAndHandles	; must do this before resizing dialog

	; GetPathToIni routine
    inv GetModuleFileName,hInst,addr Buff,256    ; get App filename
    inv GetFullPathName,addr Buff,256,offset IniName,addr tmp
    mov esi,tmp	; filename part
    .repeat
    	lodsb
    	.if al==0
    		mov al,"."
    		mov byte ptr[esi-1],al
    	.endif
    .until al=='.'
    mov dword ptr [esi],00696e69h  ; "ini" + terminator

	; get the position and size from the last time the program was run
	inv GetPrivateProfileString,addr Position,addr Position,addr Position,addr Buff,260,addr IniName
	cmp byte ptr [Buff],"P"
	je NoDat
	mov edi,offset WinPlace
	mov edx,offset Buff
	mov ecx,11
	Doit:
		call ReadLong
		stosd
	loop Doit
	inv SetWindowPlacement,hWin,addr WinPlace	; will also trigging FormResize

NoDat:
	inv GetCommandLine	; command line will contain the name of the program in quotes
						;  (followed by the folder name if it was run from context menu)
	inc eax				; mov past first quote
	mov tmp,eax			; will be end of name
	mov esi,eax
	mov edi,offset Buff	; where we will store path to this program
@@:
	lodsb
	stosb
	cmp al,0
	je 	dd3		; bad
	cmp al,'"'
	je	dd1		; end of name
	cmp al,"\"
	jne @b
	mov tmp,edi	; possible location of one past last backslash in path
	jmp @b
dd1:
	mov edi,tmp
@@:
	lodsb
	cmp al,' '	; should be a space
	je @b
	cmp al,'"'
	je	savbuf
	; no path, force local path
	mov word ptr [esi],2eh	; "."
savbuf:	
	mov edi,offset Buff2	; where we will store path to search
@@:
	lodsb
	stosb
	cmp al,0
	je 	dd2		; done prematurely
	cmp al,'"'
	jne	@b
	mov byte ptr[edi-1],0
dd2:
	inv SendMessage,hStartFolder,WM_SETTEXT,0,addr Buff2

	mov edi,tmp		; end of programs folder
	mov esi,soff("newpaths.txt")
	mov ecx,13
	rep movsb
	inv SendMessage,hStringsFile,WM_SETTEXT,0,addr Buff
	mov edi,tmp
	mov esi,soff("Result.txt")
	mov ecx,11
	rep movsb
	inv SendMessage,hOutputFile,WM_SETTEXT,0,addr Buff
dd3:

	; create output bufer
	;OutputBuf	db OutputBufSize dup (?)
	;OutputBufEnd dd ? 
	inv HeapAlloc,HeapHandle,0,OutputBufSize
	or eax,eax
	jz HeapError
	mov OutputBuf,eax
	mov OutputPtr,eax		; initial value of pointer
	add eax,OutputBufSize
	mov OutputBufEnd,eax	
	; we now have a nice large buffer to use for scratch

	mov ecx,offset PrintFileNamesOption
	mov ebx,hPrintFileName
	call SetOption
	mov ecx,offset CaseSensitiveOption
	mov ebx,hCaseSensitive
	call SetOption
	mov ecx,offset NumberLinesOption
	mov ebx,hNumberLines
	call SetOption

	call SetupFileTypesCombo
	

   	inv CreateFont,-9,0,0,0,0,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FIXED_PITCH or FF_DONTCARE,soff("Sheldon")
	mov hFont,eax
	m2m tmp,hEText1
SetupRichEdit:
	mov cf.cbSize,0
    inv SendMessage, tmp, EM_GETCHARFORMAT, 0, addr cf
    mov cf.crBackColor, 189 shl 16 or 220 shl 8 or 235 ;rgb(235,220,189)
	mov cf.cbSize,sizeof cf
    mov cf.dwMask,CFM_COLOR or CFM_BACKCOLOR
    inv SendMessage, tmp, EM_SETCHARFORMAT, SCF_ALL, addr cf
    .if hFont!=0
		inv SendMessage,tmp,WM_SETFONT,hFont,TRUE
	.endif
    inv  SendMessage,tmp,EM_SETTEXTMODE,TM_PLAINTEXT,0
    ; subclass the rich edit controls so we can get the tab key
    inv SetWindowLong,tmp,GWL_WNDPROC,EditWndProc
	mov OldEditWnd,eax		; save old routine

	mov eax,tmp
	.if eax==hEText1
		m2m tmp,hEText2
		jmp SetupRichEdit	; do other box also
	.endif

	inv SetFocus,hEText1
	
	; create table to convert lower case to upper case for matching purposes
	mov eax,CaseUpper
	mov	ebx,0
MakeTable:
	mov byte ptr[eax],bl		; save the character
	mov	byte ptr[eax+256],bl 	; no change table
	cmp	bl,'a'
	jb	@f		; ok
	cmp	bl,'z'
	ja	@f
	xor	byte ptr[eax],20h	; flip bit to make upper case
@@:
	inc	eax
	inc	ebx
	or	bl,bl
	jnz	MakeTable

;UCaseTable  db 65536*2 dup (?)
	inv HeapAlloc,HeapHandle,HEAP_ZERO_MEMORY,65536*2
	mov UCaseTable,eax
	or eax,eax
	jz HeapError

	mov eax, UCaseTable	; make giant ucase lookup table to convert two characters at a time
	mov	edx,0
MakeTable2:
	mov ecx,edx
	cmp	cl,'a'
	jb	@f		; ok
	cmp	cl,'z'
	ja	@f
	xor	cl,20h	; flip bit
@@:
	cmp	ch,'a'	; also do second character
	jb	@f		; ok
	cmp	ch,'z'
	ja	@f
	xor	ch,20h	; flip bit
@@:
	mov word ptr[eax],cx
	add	eax,2
	inc	edx
	or	dx,dx
	jnz	MakeTable2
	
	jmp GoodRet

HeapError:
	inv ShowHeapError,soff("FormLoad")

ErrorRet:
	stc
	jmp FormLoadRet
	
GoodRet:
	clc
FormLoadRet:
	popa
    ret
FormLoad Endp

FormUnload proc uses ebx
    mov WinPlace.iLength, sizeof WinPlace   ; save current size and location of program for next time
    inv GetWindowPlacement,hWin,addr WinPlace
    mov edi,offset Buff
    mov esi,offset WinPlace
    mov ecx,11
    Doit:
    	lodsd
    	call dwtoax2
    	mov al,","
    	stosb
    loop Doit
    mov dword ptr [edi-1],0	; need at least two zbt
	inv WritePrivateProfileString,addr Position,addr Position,addr Buff,addr IniName

	mov ebx,offset PrintFileNamesOption	; save user prefered options
	mov ecx,hPrintFileName
	call SaveOption
	mov ebx,offset CaseSensitiveOption
	mov ecx,hCaseSensitive
	call SaveOption
	mov ebx,offset NumberLinesOption
	mov ecx,hNumberLines
	call SaveOption

	call SaveCurrentFileSpec  ; save user prefered file specifications
		
	inv DeleteObject, hFont
    mov RunningFlag,0
    ret
FormUnload Endp

SaveCurrentFileSpec proc
	; save user preferred file specifications for next time
	inv SendMessage,hFileTypes,WM_GETTEXT,512,addr Buff
	add eax,offset Buff
	.repeat
		dec eax
		movzx ecx,byte ptr [eax]
	.until cl!=32
	mov byte ptr [eax+1],0
	inv WritePrivateProfileString,addr Options,addr FileSpec,addr Buff,addr IniName
	ret
SaveCurrentFileSpec EndP


;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------
;----------------------- Data for the search routine -----------------------------------------------
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------

.data?  
; ------------ for GetNextFile ----------------
wfd WIN32_FIND_DATA <?>
SearchHandle dd ? ; search handle for FindNextFile for current level
LastFilePtr  dd ? ; location of end of path for current level
Level	     dd ? ; depth into sub-folders
pnt		     dd ? ; offset into heap. heap will contain pairs of LastFilePtr,SearchHandle for each level
Phase	     dd ? ; first time through requires setup

; -----  for search strings ------------
NumChars	 dd ? ; scratch to compute size of heap containing search and not strings
NumFileSpecs dd ?

NumItems 	 dd ? ; number of "strings to search for" found
NumNots 	 dd ? ; number of disqualifying strings (nots) found
StartNots 	 dd ? ; pointer into heap2 of start of nots
RowNum		 dd ? ; row number in search-for edit window 

ETextx		 dd ? ; scratch for picking up lines of search strings and nots
doingext 	 dd ? ; scratch for parsing file extensions wanted
hInFile		 dd ? ; handle to input file being searched
hOutFile 	 dd ? ; handle of output file
CaseTable 	 dd ? ; will contain table start address of small table for changing lower to upper
                  ;    (CaseUpper) or no change table (CaseUpper+256)
CurBase		 dd ? ; scratch for setupsearchstrings
maxll 	     dd ? ; length of each line in search table.  Maximum of MaxSearchString (currently 1022).
maxsl		 dd ? ; maximum length of any search string wanted
minsl		 dd ? ; minimum length of any search string wanted

WantPrintFileName 	  dd ?  ; flag to print file name in output file
WantNumberLines 	  dd ?  ; flag to number lines in output file
WantUpper	 		  dd ?  ; flag that upper case is wanted (not case sensitive)

MySP			dd ?   ; My stack pointer to make sure everything is reset properly

FirstPrintFlag 	dd ?

.data
SearchName db "Search",0	; for error comments and button
EditName   db "Edit Output",0	; for button

.code


;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------

;  This is the main search routine -------------------------------

SearchClick proc ; this will be run as a separate thread to allow user abort
	
	pusha	; uses just about everything
	mov MySP,esp	; easier than tracking everything
	
	call DisableAllHandles
	
	call SetupStartFolder ; check the starting folder for errors
	jc	SearchClickRet

	inv	SendMessage,hPrintFileName,BM_GETCHECK,0,0
	mov	WantPrintFileName,eax

	inv	SendMessage,hNumberLines,BM_GETCHECK,0,0
	mov	WantNumberLines,eax

	call SetupSearchStrings
	jc	SearchClickRet

	call SetupFileNamesWanted
	jc	SearchClickRet

	call SetupOutputFile
	jc	SearchClickRet
	
	call SetupDataBuffers
	jc	SearchClickRet


;   ---------   search for files wanted --------------------------

.data?		; Buffers reset once for each time user searches
filnam db 260 dup (?)
filext db 260 dup (?)
FilesInThePath	dd ?
FilesToSearch 	dd ?
MatchingFiles	dd ?
FileOpenErrors	dd ?
ReadErrors		dd ?
UpperWanted		dd ?	; flag, 0=not case sensitive.  Set by SetupSearchStrings
MatchesFound 	dd ?
HadToReRead 	dd ?	; number of times we had to reread a file for printing
CompBuf			dd ? ; compare buffer.  Read buf, or upper cased read buffer if not case sensitive
.code

	mov MatchesFound,0
	mov	FileOpenErrors,0
	mov ReadErrors,0
	mov HadToReRead,0
	mov	FilesInThePath,0
	mov	FilesToSearch,0
	mov MatchingFiles,0
	mov FirstPrintFlag,0
	mov eax,DataIn	; assume case sensitive, so don't use other buffer
	.if UpperWanted==0
		mov eax,DataU	; not case sensitive
	.endif
	mov CompBuf,eax

FileSearch:

	call StartTimer
	call SetupGetNextFile	; everything ok, set up for real
	jc	SearchClickRet
	mov StopSearch,1	; active
	inv SendMessage,hSearch,WM_SETTEXT,0,soff("Abort Search")
	inv	EnableWindow,hSearch,TRUE
	inv SetDlgItemInt,hWin,FilesInPath,0,TRUE
	inv SetDlgItemInt,hWin,FilesSearched,0,TRUE
	inv SetDlgItemInt,hWin,FilesFound,0,TRUE
	inv SetDlgItemInt,hWin,LinesFound,0,TRUE

FileSearchLoop:
	cmp	StopSearch,2	; did user hit abort?
	jz	SearchClickRet
	call GetNextFile
	jc	FilesDone
	mov	edx,wfd.nFileSizeLow
	add	edx,wfd.nFileSizeHigh
	jz	FileSearchLoop	; ignore zero byte length files
	mov	edi,offset ResultFile
	mov	esi,offset FileN
	mov ebx,CaseUpper	; want lower converted to upper case for file names
CheckIfResultFile:
	movzx eax,byte ptr[esi]	; be sure this isn't the result file
	mov	al,[eax+ebx]	; convert to upper case
	cmp	al,byte ptr[edi]
	jne	NotResultFile	; ok, not result file
	or	al,al
	jz	FileSearchLoop			; ignore result file
	add	esi,1
	add	edi,1
	jmp	CheckIfResultFile

NotResultFile:
	inc FilesInThePath
	inv SendMessage,hDoingFile,WM_SETTEXT,0,addr FileN
	inv SetDlgItemInt,hWin,FilesInPath,FilesInThePath,TRUE
	mov esi,offset FileN	; see if it one we want
	mov edi,offset filnam
	mov byte ptr filext,0	; terminate extension in case it's missing
FileSearch1:
	movzx eax,byte ptr[esi]
	inc	esi
	mov	al,[ebx+eax]		; convert to upper case	
	cmp	al,0
	je	FileSearch2
	.if al=="\"
		mov	edi,offset filnam	; was a path, start filename over	
		jmp	FileSearch1
	.elseif al!="."
		stosb
		jmp FileSearch1	; go get next character of filename or extension
	.endif
	mov byte ptr[edi],0		;terminate file name
	mov edi,offset filext	; now save extension
	jmp FileSearch1		
	
FileSearch2:	
	stosb	; terminate extension (or file if extension is missing)
	cmp	StopSearch,2	; did user hit abort?
	jz	SearchClickRet
TestFileNameForMatch:
; now compare filename to those wanted

	mov	ecx,NumFileSpecs	; how many to check
	mov	tmp2,ecx	; counter
	mov	esi,HeapFSpecs
TryNextFileSpec:
	mov	doingext,0	; start with file name
	mov	edi,offset filnam
TryNextSection:
	mov	edx,[esi]	; pointer to next section
	mov	tmp,edx		; save
	add	esi,4		; step past pointer

FileNameMatchLoop:
	mov al,[esi]
	inc	esi
	mov	ah,[edi]
	inc edi
	cmp al,'*'
	je	FileNameSectionMatches
	cmp	al,'?'
	jne checkforchar
	or	ah,ah		; was there a character to match to
	jz	FileNameSectionMatches	; done, good match
	jmp	FileNameMatchLoop	; good, check next char	
checkforchar:
	cmp	al,ah		; did they match
	jne	CheckNextFileSpec	; no good, try next file spec against this name
	or	al,al		; is this the end?
	jz	FileNameSectionMatches	;good, all done
	jmp	FileNameMatchLoop	; go try next char	

CheckNextFileSpec:
	dec	tmp2
	jz	FileSearchLoop	; don't want this filename at all
	mov	esi,tmp			; location of next file spec section
	cmp	doingext,0
	jne	TryNextFileSpec	; ok, all set up to try next spec on this file
	mov	esi,[esi]		; get pointer to extension
	jmp	TryNextFileSpec	

FileNameSectionMatches:
	cmp	doingext,0
	jne	FullNameMatches	; good, go search this file for text
	mov	doingext,1		; now doing extension
	mov	esi,tmp			; location of extension
	mov	edi,offset filext
	jmp	TryNextSection

FullNameMatches:
	inc	FilesToSearch
	inv SetDlgItemInt,hWin,FilesSearched,FilesToSearch,0

;  -----------------------------  read the file -----------------------------------	
	
.data?
BytesRead 	dd ? ; Bytes read on last ReadFile
TotalBytes	dd ? ; Total bytes read from file (i.e. file pointer)
BufferByte  dd ? ; file pointer for start of current buffer
CurLineNum	dd ?
CurLByte	dd ? ; file byte pointer of start of current line
;CurLHigh	dd ? ; high portion
LinesRead   dd ? ; number of lines read so far from this file
eof			dd ? ; eof flag
ThisFileMatches dd ?

.code
	mov TotalBytes,0
;	mov TotalHigh,0		; aborted attempt at doing files greater than 4 giga bytes
	mov BufferByte,0
;	mov BufferHigh,0
	mov LinesRead,0
	mov eof,0
	mov ThisFileMatches,0
	mov CurLineNum,1

	inv CreateFile,addr FileN,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
    
    .if eax==INVALID_HANDLE_VALUE
	    inc FileOpenErrors
    	jmp	FileSearchLoop		; no good, try another.  (may want to keep error count here)
	.endif
	mov hInFile,eax
	call ReadMoreFile	; get first block of data
	cmp BytesRead,0
	je  EndOfFile	; should never happen, zero length file should have never been opened
	jmp StartSearch

;-------------------------- read more file routine ---------------------------------

align 16
ReadMoreFile:			; Need more data to work with.
	.if	StopSearch==2	; did user hit abort?
		pop eax		; remove caller address
		jmp	EndOfFile
	.endif
	.if eof==1
		ret		; local return
	.endif
	pusha	; save current condition for Search

    inv ReadFile,hInFile,DataIn,BufSize,addr BytesRead,0

    .if eax==0
		popa



    	pop	eax	; remove callers return address
    	jmp ErrorReading
	.endif
	.if BytesRead==0
		mov eof,1			; file was exactly a multiple of BufSize, already have all data
		popa
		ret	; local return
	.endif
	.if BytesRead<BufSize	; should be last of file
		mov eof,1
		mov eax,DataIn
		add eax,BytesRead
		.if byte ptr[eax-1]!=10
			mov byte ptr [eax],10	; force a line terminator
			inc BytesRead
		.endif
	.endif
	m2m BufferByte,TotalBytes	; save start of buffer (last file pointer)
	mov eax,BytesRead	;bytes to process
	add TotalBytes,eax	; new file pointer
	jc	EndOfFile		; only do first 4G bytes
	add	eax,DataIn
	mov [eax],byte ptr 10  ; end of line terminator just in case 
	
	;------------------ convert case if needed ---------------------------
	cmp UpperWanted,1
	je	ReadMoreFileRet	; case sensitive, don't convert to upper case
	;** note, keep this alignment for fastest conversion
	mov esi,DataIn
	align 16
	mov edi,DataU
	mov ecx,BytesRead	; work backwards from end of buffer
	;inc	ecx			; also pick up zero byte terminator
	;add	ecx,3		; add enough to get to or past even 4 byte boundary
	;sub	ecx,4		; step back to start of last word of buffer
	; the results of the above 3 operations would be of course +1+3-4 or zero, no change
	and ecx,not 3	; round down to nearest even dword
	mov ebx,UCaseTable
	nop
ucaseloop:		 	; fastest alignment at address ending in 6 for AMD cpus
	movzx edx,word ptr [esi+ecx+2]
	movzx eax,word ptr [esi+ecx]
	mov	edx,[ebx+edx*2-2]	; pick up replacement characters, upper half+junk
	mov	dx,[ebx+eax*2]		; pick up replacement characters, lower half
	mov [edi+ecx],edx
	sub ecx,4
	jnc	ucaseloop
ReadMoreFileRet:
	popa
	ret		; local return
;---------------------------------- end of read more file -------------------
.data?
WantThisLine dd ? ; state of line.  0=searching, 1=found match, looking for not
NewStart  	 dd ?
sflg  		 dd ? ; search flag, !0= switch between searchstring and not strings. NumNots>0, Wantthisline=0
                  ; Numnots will be the default.  will be changed by match and newline routines
MatchLoc	 dd ?
ModAmt		 dd ? ; amount subtracted from actual eof location to provide overlap on new read
.code
	; buffer converted to upper case if needed, now search for strings
StartSearch:
	mov WantThisLine,0
	mov MatchLoc,0
	m2m sflg,NumNots
	; first search of new file, set up pointers
	mov esi,CompBuf		; compare buffer, either DataIn or DataU
	mov ecx,BytesRead	; count down available bytes
	cmp ecx,minsl		; check minimum characters that could contain smallest search string
 	jb	EndOfFile		; not enough characters in file for minimum string to be found
	mov CurLByte,0
	mov edx,STable		; sorted search table pointers
	m2m ModAmt,maxsl	; want maximum size string for overlap between reads.
	.if ecx<maxsl
		m2m ModAmt,minsl	; must have read in entire file, only allow space for smallest string.
	.endif
 	sub ecx,ModAmt		; need to have maxsl characters available for overlap between reads
 	add	ecx,1			; need to include the starting character also.
	
	; most of the time will be in this rountine (unless reading actual disk in which case this is irrelevant)
	align 16  ; test best alignment  ********************
ContinueSearch:
	; note: esi,ecx and edx must be preserved or adjusted when outside the search loop if returning here (eg. newline)
	movzx eax,byte ptr[esi]
	cmp	al,10
	je	NewLine  ; Started new line
	mov edi,[edx+eax*4]	; pick up location of first search string that starts with this character
	or	edi,edi
	jnz	CheckNextString ; have string to check

GetNextChar:  ; determine if it's time to look for a not-string
	cmp sflg,0
	je	GetNextChar1 ; just continue with next character, edx already = STable, or NTable for line with match	
	cmp edx,STable	; We have nots, if we are searching for strings, switch to nots.
	jne	WasNots		; no, was searching nots, switch back to strings and check next char
	mov edx,NTable	; now search nots
	jmp ContinueSearch	; search this same character for a not
WasNots:
	mov edx,STable	; switch back to search strings and look at next character		
GetNextChar1:	
	inc esi

GetNextChar2:
	dec ecx
	jnz	ContinueSearch	; else, not enough for testing, go get more or wrapup
	push offset ContinueSearch	; where to return to
	jmp GetMoreData

CheckNextString:
	mov ebx,0		; start with first character after current location
CheckNextChar:
	inc ebx
    mov al,byte ptr[edi+ebx]	; next character of search string
    or	al,al	; fulfilled search string
    jz	Match
    cmp	al,byte ptr[esi+ebx]	; compare search string to (fixed) input buffer
	je	CheckNextChar	; still matching
	ja	GetNextChar		; too big. Since search strings are sorted, nothing that's left can ever match 
	add	edi,maxll		; not yet, try next search string
	mov al,byte ptr [edi]	; do first characters still match?
	cmp al,byte ptr [esi]
	je CheckNextString	; yes, go check rest of string
	jmp GetNextChar 	; NoMatch

Match:
	cmp edx,NTable
	je	FoundANot		; don't want this line
	mov WantThisLine,1	; want this line
	mov eax,esi			; save location of matching string
	sub eax,CompBuf
	add eax,BufferByte	; byte number within file of match
	mov MatchLoc,eax
	sub eax,CurLByte
	.if eax>maxlinesize
		sub MatchLoc,20	; starting byte for print.  ( show 20 bytes before matching string)
	.else
		mov eax,CurLByte
		mov MatchLoc,eax
	.endif
	cmp NumNots,0
	je	FindEndOfLine	; want this line
	mov edx,NTable		; now search only for nots
	mov sflg,0			; do not want to switch between strings and not for rest of line
	jmp ContinueSearch	; go look for nots
	
	;--------------------------------------------------------------
GetMoreData:		;  a called routine
	cmp	eof,2
	je	NoMoreData	; out of data
	cmp	eof,1
	jne HaveMore	; still more data left
	mov eof,2		; flag that we are finishing off any remaining bytes
	mov eax,ModAmt
	.if eax==maxsl
		add	ecx,eax   ;maxsl	; actual number of bytes left
		;dec ecx
		sub ecx,minsl	; minimum needed to contain smallest string
		;inc ecx	; dec + inc = zero
		jz	NoMoreData	; no data left to search, minsl=maxsl
		m2m ModAmt,minsl
	.else
		jmp NoMoreData
	.endif
	ret			; local return
HaveMore:	
	push esi
	add	ecx,maxsl		; bytes left
	dec ecx
	mov edi,CompBuf		; start of data
	sub edi,ecx			; put them before read buffer
	mov NewStart,edi	; new start of line
	rep	movsb			; move this small number of characters
	pop esi
	.if esi>=DataU		; was it in the changed case buffer?
		mov ecx,minsl	; yes, move raw also
		mov edi,DataIn
		sub edi,ecx
		rep movsb
	.endif
	pop	ebp				; where I will return to, ReadMoreFile will save
	call ReadMoreFile	; readmorefile will save all registers
	push ebp			; put it back for the return
	mov esi,NewStart
	mov	ecx,BytesRead	; add maxsl for part moved, sub maxsl for trailing extras yields zero
	inc ecx				; and one more to test first char of maximum string
	ret			; local return
NoMoreData:
	pop eax				; get rid of callers return address
	jmp OutOfData
	;----------------------------------------------------------------------

FoundANot:
	mov WantThisLine,0	; no longer want this line
	mov MatchLoc,0
	; fall through to end of line cleanup

FindEndOfLine:	; here if a search string or notstring found.  Move to end of current line.
	cmp byte ptr [esi],10
	je	NewLine
	inc	esi
	dec ecx
	jnz	FindEndOfLine
	.if eof==1
		add ecx,ModAmt		; out of data, find last newline, or faked one if none exists
		jmp FindEndOfLine
	.endif
	call GetMoreData
	jmp	FindEndOfLine

.data?
LineStrt dd ?
LineStop dd ?
SaveEsi	 dd ?	; needed to pick up where we left off
SaveEcx  dd ?	; needed to pick up where we left off
StartChr dd ?   ; starting character/ byte within line (for prints)
FilePos  dd ?	; current file pointer
FileHigh dd ?   ; high part of file pointer
.code

NewLine:
	cmp WantThisLine,0
	je	NewLine2		; Normal case, don't want this line

	mov SaveEsi,esi		; save for later
	mov SaveEcx,ecx

	inc MatchesFound	; debug
	inv SetDlgItemInt,hWin,LinesFound,MatchesFound,0

TimeToPrint:

	mov eax,MatchLoc	; where printing is to start
	cmp eax,BufferByte	; is it in the buffer
	jae	okbuf

	; else, the dang thing got away from us, read it back in
	inc HadToReRead		; this should happen very rarely
	mov FileHigh,0		; get current position of file to restore later
	inv SetFilePointer,hInFile,0,addr FileHigh,FILE_CURRENT
	mov FilePos,eax
	cmp eax,0FFFFFFFFh
	je  ErrorReading
	mov eax,SaveEsi		; last byte to print.
	sub eax,CompBuf
	add eax,BufferByte	; byte number within file
	sub eax,MatchLoc	; subtract out where to start
	mov tmp2,eax		; number of bytes to read
	.if eax>maxlinesize
		mov tmp2,maxlinesize
	.endif	
	inv SetFilePointer,hInFile,MatchLoc,addr FileHigh,FILE_BEGIN ; reset file pointer to start of line
	cmp eax,0FFFFFFFFh
	je  ErrorReading
	mov eax,tmp2
	inv	ReadFile,hInFile,DataBack,eax,addr tmp2,0
	cmp	eax,0
	je	ErrorReading
	inv SetFilePointer,hInFile,FilePos,addr FileHigh,FILE_BEGIN ; restore file pointer for next read
	cmp eax,0FFFFFFFFh
	je  ErrorReading
	mov eax,DataBack
	mov LineStrt,eax
	add eax,tmp2
	mov LineStop,eax
	jmp PrintTheLine
		
okbuf:
	sub eax,BufferByte	; eax still contains MatchLoc
	add eax,DataIn
	mov LineStrt,eax	; where print will start

	mov eax,esi		    ; this will be end of line.  esi should still be good
	sub eax,CompBuf
	add eax,BufferByte	; convert to byte within file
	sub eax,MatchLoc	; how many to print	
	
	.if eax>maxlinesize
		mov eax,LineStrt
		add eax,maxlinesize
		mov LineStop,eax
	.else
		mov eax,esi
		sub eax,CompBuf
		add eax,DataIn
	.endif
	mov LineStop,eax

PrintTheLine:

	mov eax,MatchLoc
	sub eax,CurLByte
	mov StartChr,eax	; offset into line of start for print
	mov eax,OutputBufEnd
	sub eax,OutputPtr
	.if eax < 260+28+maxlinesize		; not enough room for filename, linenumber, and line segment
		call WriteOutputBuf	;time to flush	
	.endif
	.if	ThisFileMatches != 1	; is it the first time for this file?
		.if WantPrintFileName
			mov edi,OutputPtr
			.if FirstPrintFlag==1	; need extra blank line for start of new file
				mov word ptr [edi],0A0Dh
				add edi,2
			.endif
			mov al,'"'
			stosb
			mov esi,offset FileN
			.repeat
				lodsb
				stosb
			.until al==0
			mov dword ptr [edi-1],000A0D22h	;  ",cr,lf
			add edi,2	; ( was already past zbt)
			mov OutputPtr,edi
		.endif
		mov ThisFileMatches,1
		add	MatchingFiles,1
		inv SetDlgItemInt,hWin,FilesFound,MatchingFiles,0
	.endif
	
	mov esi,LineStop
	mov eax,LineStrt	; start of line
	sub esi,eax
	mov edi,OutputPtr
	.if WantNumberLines
		mov eax,CurLineNum
		call dwtoax2
		mov al,":"
		stosb
		mov eax,StartChr
		.if eax!=0
			call dwtoax2
		.endif
		mov al," "
		stosb
		mov OutputPtr,edi
	.endif
	mov esi,LineStrt	; where to start print from
	mov eax,LineStop
sloop:
	movsb
	cmp esi,eax
	jne sloop
	mov al, byte ptr [edi-1]	; was it a newline
	.if al!=10
		.if al!=13
			mov al,13
			stosb
		.endif
		mov al,10
		stosb
	.endif
	mov OutputPtr,edi

	mov FirstPrintFlag,1
	mov ecx,SaveEcx ; restore
	mov esi,SaveEsi	; restore

NewLine2:

	inc CurLineNum
	inc	esi
	mov eax,esi
	sub eax,CompBuf		; number of bytes into buffer
	add eax,BufferByte
	mov CurLByte,eax
	mov edx,STable		; make sure we are looking at search strings
	mov WantThisLine,0
	m2m sflg,NumNots	; reset search flag
	jmp	GetNextChar2

OutOfData:
	; do any leftover processing on old file here
	jmp EndOfFile

;-----------  routines for this proc called from more than one place -----------------------

WriteOutputBuf:
	mov eax,OutputPtr
	sub eax,OutputBuf
	.if !Zero?
		pusha
		inv WriteFile,hOutFile,OutputBuf,eax,addr junk,0
		.if eax==0
			jmp GenericError	; fatal, stop processing. Wrapup will fix stack
		.endif
		popa
		m2m OutputPtr,OutputBuf	; reset pointer
	.endif
	ret


;------------------------- wrapup ----------------------------------------
ErrorReading:
	inv GetErrDescriptionx,soff("error reading file")   
	msg FileN    
	inc ReadErrors		; and fall through for now	

EndOfFile:
	inv CloseHandle,hInFile
	mov	hInFile,0
	mov eax,ThisFileMatches
	.if eax>0
		inv SetDlgItemInt,hWin,FilesFound,MatchingFiles,0
		inv SetDlgItemInt,hWin,UnreadableFiles,FileOpenErrors,0
		inv SetDlgItemInt,hWin,FileReadErrors,ReadErrors,0
		inv SetDlgItemInt,hWin,Rereads,HadToReRead,0
	.endif
	cmp	StopSearch,2	; did user hit abort?
	jz	SearchClickRet
	jmp	FileSearchLoop	; go test next file

FilesDone:
	jmp SearchClickRet

GenericError:
	inv	GetErrDescriptionx,addr SearchName	; print out error and quit

SearchClickRet:

	call FinishTimer
	inv SetDlgItemInt,hWin,LinesFound,MatchesFound,0
	inv SetDlgItemInt,hWin,FilesFound,MatchingFiles,0
	inv SetDlgItemInt,hWin,UnreadableFiles,FileOpenErrors,0
	inv SetDlgItemInt,hWin,FileReadErrors,ReadErrors,0
	inv SetDlgItemInt,hWin,Rereads,HadToReRead,0
	inv FreeHeap,addr HeapData
	inv FreeHeap,addr HeapFSpecs
	inv FreeHeap,addr HeapSearch
	cmp hOutFile,0
	je SearchClickRet2
	call WriteOutputBuf
	mov eax,OutputPtr
	sub eax,OutputBuf
	inv WriteFile,hOutFile,OutputBuf,eax,addr junk,0
	or eax,eax
	jz OutputFileError
	inv CloseHandle,hOutFile
	or	eax,eax
	jnz	SearchClickRet2
OutputFileError:
	inv	GetErrDescriptionx,addr SearchName
SearchClickRet2:
	mov hOutFile,0
	cmp	hInFile,0
	je SearchClickRet3
	inv CloseHandle,hInFile
	or	eax,eax
	jnz	SearchClickRet2
	inv	GetErrDescriptionx,addr SearchName
SearchClickRet3:
	inv SendMessage,hSearch,WM_SETTEXT,0,addr SearchName
	call EnableAllHandles
	mov StopSearch,0	;advises main window thread has terminated
	inv	SetFocus,hEditOutput
	mov esp,MySP	; restore proper stack pointer in case of early exit
	popa
	ret

SearchClick EndP


;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------
;------------------------ the following are setup routines needed before searching -----------------
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------

DisableAllHandles proc	; make sure user doesn't click on something while searching
	mov ebx,StartOfHandles		; first one of the group
	.while ebx<LastUser
	    mov eax,[ebx]
		inv	EnableWindow,eax,FALSE	; disable while searching
		add ebx,4
	.endw
	ret
DisableAllHandles EndP

EnableAllHandles proc	; back to normal, re-enable everything
	mov ebx,StartOfHandles		; first one of the group
	.while ebx<LastUser
	    mov eax,[ebx]
		inv	EnableWindow,eax,TRUE	; re-enable
		add ebx,4
	.endw
	ret
EnableAllHandles EndP

SetupDataBuffers proc	; Get heap space to perform the search

	; Get some buffer space to work in
;		   db 64 dup (?)
;DataBack  db MaxBack dup (?)  ; Back buffer of previously read data
;DataIn	   db BufSize dup (?)	; Current data
;DataU     db BufSize dup (?)	; Current data converted to upper case
;          db 64 dup (?)			; guard bytes 
	DataMem = 64+MaxBack+BufSize+64+BufSize+64
	inv HeapAlloc,HeapHandle,HEAP_ZERO_MEMORY,DataMem
	mov HeapData,eax
	.if eax==0
		inv ShowHeapError,soff("SetupDataBuffers")
		jmp ErrorRet
	.endif
	add	eax,64		; make sure we are high enough
	and	eax,not 63	; mask off unwanted bits to align to a 64 byte boundary
	mov DataBack,eax
	add eax,MaxBack
	mov DataIn,eax
	add eax,BufSize+64
	mov DataU,eax
	clc
	ret	
ErrorRet:
	stc
	ret
SetupDataBuffers EndP


SetupStartFolder proc	; parse and cleanup the starting folder of the search
	inv SendMessage,hStartFolder,WM_GETTEXT,500,addr Buff
	or	eax,eax
	jz	Error0
	mov esi,offset Buff
	mov edi,offset Buff2
@@:	; discard leading blanks.  Error if end of string.
	lodsb
	cmp al,' '
	je	@b
	or	al,al
	jz	Error0
	; ok, have a character, copy rest
@@:
	stosb
	lodsb
	cmp al,0
	jne	@b		;not done yet
@@:
	dec edi
	cmp	byte ptr[edi],' '
	je	@b					; delete trailing blanks
	cmp	byte ptr[edi],'\'
	je @f
	inc	edi
	mov byte ptr[edi],'\'	; apply trailing backslash
@@:
	mov dword ptr [edi+1],002A2E2Ah	; set "*.*" search pattern, including zero byte terminator
	inv	GetFullPathName,addr Buff2,260,addr FileN,addr tmp ; Get real full name of result file
    inv FindFirstFile,offset FileN,ADDR wfd
    cmp eax,INVALID_HANDLE_VALUE  ; (-1)
    je Error0
	
	inv FindClose,eax		; done with this search handle, close it	
	mov edi,tmp				; discard "*.*"
	mov byte ptr[edi],0
	;msg FileN
	jmp NormalRet

Error0:
	msg "Please enter a valid starting Folder"
	inv SetFocus,hStartFolder
ErrorRet:
	stc
	ret
NormalRet:
	clc
	ret
SetupStartFolder EndP

.data?
tflg dd ?
numln dd ?
.code
SetupSearchStrings proc
	;  This routine will take the desired search strings and not-search strings from the edits and
	;  place them in an array of equal length lines for easy searching later.  The lines will be
	;  sorted.  Since this is a one time quickie, no attempt was made to make this run quickly. And
	;  also since there aren't enough characters possible in an edit control to be a problem.
	;  A table pointing to the start of each string, based upon the starting character is also created
	;  for easy searching later.
	inv FreeHeap,addr HeapSearch	; in case I screwed up somewhere
	m2m	CaseTable,CaseUpper		; assume not case sensitive, get table that changes from lower to upper case
	mov UpperWanted,0
	inv	SendMessage,hCaseSensitive,BM_GETCHECK,0,0
	cmp	eax,BST_CHECKED	
	jne	@f
	add	CaseTable,256	; get table that makes no changes (case sensitive)
	inc UpperWanted
@@:	
	mov maxll,0
	mov maxsl,0
	mov minsl,1024
	mov numln,1	; add a little extra space for working room
	; count lines and find largest line
	m2m	ETextx,hEText1	; do search strings first
GetAllLines1:
	inv SendMessage,ETextx,EM_GETLINECOUNT,0,0
	mov tmp3,eax	; number of rows in edit
	mov	RowNum,0	; input row number
GetLineLoop1:
	mov dword ptr Buff,MaxSearchString+2
	inv SendMessage,ETextx,EM_GETLINE,RowNum,addr Buff
	.if byte ptr [Buff+eax-1]==13
		sub eax,1
	.endif
	inc	RowNum			; set up to get next row
	or	eax,eax
	jz	CheckLineCount1	; empty line, ignore

	.if eax > maxll
		.if eax > MaxSearchString
			msg "Maximum length of a search string is 1022 characters"
			jmp SetupSearchError
		.endif
		mov maxll,eax
	.endif
	.if eax < minsl
		mov minsl,eax
	.endif	
	inc numln
CheckLineCount1:
	dec	tmp3
	jnz GetLineLoop1
	
	mov eax,hEText2
	cmp eax,ETextx
	je	@f	; all done
	mov ETextx,eax
	jmp GetAllLines1
@@:
	mov	eax,maxll
	mov maxsl,eax	; actual largest search string found for comparisons
	add maxll,4 ; room for zerobyte terminator plus make an even dword in size
	and	maxll,not 3h  ; mask off last three bits.
	mov eax,maxll	; get maximum line size
	mul	numln	; bytes needed for search table
	mov NumChars,eax
	add	eax,67	; add one word to insure stop and round up to nearest 16 dwords
	and eax,not 63

	inv HeapAlloc,HeapHandle,HEAP_ZERO_MEMORY,eax
	mov HeapSearch,eax
	.if eax==0
		inv ShowHeapError,soff("SetupSearchStrings")
		jmp ErrorRet
	.endif

	; now get lines for real, store, and upper case as needed
	mov NumItems,0
	mov NumNots,0
	mov	edi,HeapSearch
	mov tmp,edi		; remember where pointer goes
	m2m	ETextx,hEText1	; do search strings first
	mov tflg,0
	mov	ebx,CaseTable	; get table to use 
GetAllLines:
	inv SendMessage,ETextx,EM_GETLINECOUNT,0,0
	mov tmp3,eax	; number of rows in edit
	mov	RowNum,0	; input row number
GetLineLoop:
	mov esi,offset Buff
	mov edi,tmp
	mov dword ptr Buff,1024
	inv SendMessage,ETextx,EM_GETLINE,RowNum,offset Buff
	.if byte ptr [Buff+eax-1]==13
		sub eax,1
	.endif
	inc	RowNum			; set up to get next row
	or	eax,eax
	jz	CheckLineCount	; empty line, ignore
	mov	ecx,eax			; keep track of countmsg ecx
	mov	eax,0
@@:						; convert case as needed
	lodsb				; where we just copied to
	mov	al,[ebx+eax]	; pick up replacement character
	stosb				; save and increment pickup
	dec	ecx				; are we done?
	jnz	@b
	mov ecx,maxll
	add tmp,ecx			; next store location
	.if tflg == 0
		inc NumItems
	.else
		inc	NumNots
	.endif
CheckLineCount:
	dec	tmp3
	jnz GetLineLoop
	.if tflg == 0
		m2m	ETextx,hEText2
		inc tflg
		m2m	StartNots,tmp
		jmp	GetAllLines
	.endif
	cmp	NumItems,0
	jne	SortStrings
	msg	"Please enter strings to find"
SetupSearchError:
	jmp ErrorRet

SortStrings:			;---- simple selection sort -----
	mov tflg,0			; do search strings first
	mov esi,HeapSearch	; base item
	mov	ebx,NumItems	; sort the search strings first
NewType:
	cmp ebx,2	; there needs to be at least two to sort
	jb	chknots
	dec	ebx

NewBase:
	mov edx,ebx		; number to check against this base
	mov edi,esi
	mov CurBase,esi	; assume the smallest
docomp:
	add edi,maxll		; next item to compare
	mov ecx,-1
@@:
	inc ecx
	cmp	ecx,maxll
	je	swapdone		; out of characters to check
	mov ah,[esi+ecx]  	; get current lowest
	mov al,[edi+ecx]	; get new candidate
	or	ah,ah			; are we done?
	jz	NotSmaller		; out of chars, keep current smallest
	or	al,al
	jz	NewSmallest		; shorter line is smaller
	cmp	al,[esi+ecx]	; is the new one less than the old one?
	ja	NotSmaller		; not smaller, don't save
	je	@b				; can't tell yet
NewSmallest:			; is smaller
	mov esi,edi			; set temp base to smallest
NotSmaller:
	dec edx				; ok, now check next item against base
	jnz	docomp
	cmp	CurBase,esi		; out of items to check, has base changed?
	je	swapdone		; no, go try next

DoSwap:
	mov	ecx,maxll		; is smaller, get number of characters to swap
	mov edi,CurBase		;  start of smallest found is in esi
swap:
	sub ecx,4
	js	swapdone
	mov eax,[edi+ecx]
	mov edx,[esi+ecx]	; edx will be reset
	mov [edi+ecx],edx
	mov [esi+ecx],eax
	jmp swap
swapdone:
	mov esi,CurBase
	add	esi,maxll	; new base
	dec ebx			; one less to do next time
	jnz NewBase

chknots:	
	.if tflg==0
		inc tflg
		mov esi,StartNots
		mov ebx,NumNots
		jmp NewType
	.endif		
	
SetupTables:
	; for each starting character of a search string, put address of the string in the table
	;  at the location that is the value of the starting character + the start of the table 
	mov edi,STable	; start of table
	mov eax,0
	mov ecx,512
	rep stosd			; clear out any previous table data
	mov edi,STable
	mov esi,HeapSearch  ; start of search strings
	mov cl,0			; previous character found
	mov edx,NumItems
	mov tflg,0
ChkNextChar:
	movzx eax,byte ptr[esi]
	cmp cl,al
	je	@f
	mov cl,al			; don't do more than once
	mov [edi+eax*4],esi	; save first entry in search table for this character
@@:
	add	esi,maxll		; look at next search string
	dec edx
	jnz	ChkNextChar	
	.if tflg==0			; have we done both?
		mov edx,NumNots	; no, now do nots
		or 	edx,edx
		jz	NormalRet	; no nots, all done
		inc tflg
		mov esi,StartNots
		mov edi,NTable
		mov cl,0
		jmp ChkNextChar
	.endif
	jmp NormalRet

ErrorRet:
	inv FreeHeap,addr HeapSearch	; just in case it got allocated
	inv SetFocus,hEText1
	stc
	ret
NormalRet:
	clc
	ret
SetupSearchStrings EndP

SetupFileNamesWanted proc

	; separate file types for search.  Will be stored with filename and extension separated.
	;  pointer,name,pointer,ext,pointer,name,pointer,ext,pointer,name,  etc.
	;  also convert to upper case for matching to filenames found
	mov	ebx,CaseUpper	; get start of case table. will convert all to upper case for matching
	mov NumFileSpecs,0
	inv GetWindowTextLength,hFileTypes
	shl	eax,3	; allow extra space for pointers, etc.
	inv HeapAlloc,HeapHandle,0,eax
	.if eax==0
		inv ShowHeapError,soff("SetupFileNamesWanted")
		jmp ErrorRet
	.endif
	mov HeapFSpecs,eax
	mov	edi,HeapFSpecs
	inv SendMessage,hFileTypes,WM_GETTEXT,512,addr Buff	
	or	eax,eax
	jz	DoneExtension	; edi still good
	mov	doingext,0		; doing filename first
 	mov	esi,offset Buff
GetNextFileSpec:
	mov	tmp,edi	; where to store pointer
	add	edi,4	; skip space for pointer to next filename/ext
	mov	ecx,0	; count characters
gfirst:
	movzx eax,byte ptr[esi]		; get first character
	inc	esi
	cmp al,' '
	je	gfirst		; delete extra blanks
	or	al,al
	jnz	gnext2		; go process character
	cmp doingext,0
	je	DoneExtension	; out of data, all done
	jmp	DoneFileName	; done with filename

gnext:
	movzx eax,byte ptr[esi]		; get next character
	inc	esi
gnext2:
	mov	al,[ebx+eax]	; convert to upper case
	or	al,al	; out of data?
	jz	DoneFileName
	cmp al,' '	; check for blank which terminates a spec
	je	DoneFileName
	cmp	al,"."	; check for dot between file and extension
	je	gotdot
	stosb		; normal character, save
	inc	ecx		; count characters
	jmp	gnext	; go get next character
	
gotdot:
	cmp	doingext,0
	je	WrapUpName	; else was doing extension and got dot, not good.
	msg	"error in file specification, check for extra dot"
	jmp ErrExts

DoneFileName:
	cmp	doingext,1
	je	WrapExt

WrapUpName:
	.if ecx==0		; was there any characters in the name?
		mov	byte ptr[edi],'*'	; save as any name
		inc	edi
	.endif
	mov byte ptr[edi],0
	inc	edi			; zero byte terminator
	mov	doingext,1	; now doing extension
	mov	ecx,tmp
	mov	[ecx],edi	; save start of next
	mov	ecx,0		; reset count of characters for next time
	cmp	al,' '		; was it a blank terminator
	je	WrapExt2	; yes, also go make extension 
	or	al,al		; are we out?
	jnz	GetNextFileSpec		; else, no extension, just fall through and make fake extension
WrapExt2:
	mov	tmp,edi
	add	edi,4
WrapExt:
	mov byte ptr[edi],0
	inc	edi	
	mov	doingext,0	; now need name
	inc	NumFileSpecs		; count number of specs
	mov	ecx,tmp
	mov [ecx],edi	; save pointer
	cmp	al,0		; were we out of characters?
	jne	GetNextFileSpec

DoneExtension:
	cmp	NumFileSpecs,0
	jne	NormalRet
	msg	"No file specifications entered"
ErrExts:
	inv	SetFocus,hFileTypes
ErrorRet:
	stc
	ret
NormalRet:

;	msg	"number of exts found"		;test print of file specs
;	prtd NumFileSpecs
;	mov	esi,HeapFSpecs
;	mov	ecx,NumFileSpecs
;	shl	ecx,1
;	.repeat
;	mov	edx,[esi]
;	add esi,4
;	msg esi
;	mov	esi,edx
;	dec	ecx
;	.until Zero?

	clc
	ret
SetupFileNamesWanted EndP

SetupOutputFileName proc ; cleanup and check the output file name entered
	inv SendMessage,hOutputFile,WM_GETTEXT,260,addr Buff
	or	eax,eax
	jz	ofileerror
	inv	GetFullPathName,addr Buff,260,offset ResultFile,addr tmp ; Get real full name of result file
	or eax,eax
	jne	NormalRet
ofileerror:
	msg "Please enter valid output file name"
	inv SetFocus,hOutputFile
	stc
	ret
NormalRet:
	clc
	ret
SetupOutputFileName EndP

SetupOutputFile proc	; open the output file

	call SetupOutputFileName
	jc	ErrorRet

	mov	hInFile,0	; flag input file not open
	mov	hOutFile,0	; flag output file not open	
	inv CreateFile,offset ResultFile,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	.if eax==INVALID_HANDLE_VALUE
		inv GetErrDescriptionx,addr SearchName
		msg "Please enter valid output file name"
		msg ResultFile
		inv SetFocus,hOutputFile
		jmp ErrorRet
	.endif
	mov hOutFile,eax
	m2m OutputPtr,OutputBuf
	mov	esi,offset ResultFile	; convert result file name to upper case for checking later
	mov ebx,CaseUpper
	.repeat
		movzx eax,byte ptr[esi]
		mov	al,[eax+ebx]
		mov byte ptr[esi],al
		inc esi
	.until al==0
	jmp NormalRet

ErrorRet:
	stc
	ret
NormalRet:
	clc
	ret
SetupOutputFile EndP

;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------

.data?
align 16
StartingCount dq ?
EndingCount	  dq ?
Freq		  dq ?
Secs          dq ?
.data
sec2ms	dd	1000
.code

StartTimer proc
    inv QueryPerformanceCounter, ADDR StartingCount
	inv SetDlgItemText,hWin,ET,soff(" ")
	ret
StartTimer EndP

FinishTimer proc
    inv QueryPerformanceCounter, ADDR EndingCount
	cmp	eax,0
	je	FinishTimerRet
	
	inv QueryPerformanceFrequency, ADDR Freq
	mov	ecx,dword ptr[StartingCount]
    sub dword ptr[EndingCount],ecx
    mov	ecx,dword ptr[StartingCount+4]
    sbb dword ptr[EndingCount+4],ecx
    IFDEF _EMMS
      EMMS
    ENDIF

    finit
    fild  EndingCount
    fild  Freq
    fdiv
    fild  sec2ms
    fmul
    fistp EndingCount
	push esi
	push edi
    mov eax,dword ptr EndingCount
    mov edi,offset Buff
    call dwtoax2
    mov dword ptr PreBuff,'0000'
    mov eax,dword ptr [edi-3]	; insert decimal point
    mov dword ptr [edi-2],eax
    mov byte ptr[edi-3],'.'
    mov esi,offset Buff
    sub edi,3
    .if edi<esi
   		mov esi,edi
    .endif
    inv SetDlgItemText,hWin,ET,esi
	pop edi
	pop esi

FinishTimerRet:
	ret
FinishTimer EndP

ShowFile proc uses ecx esi edi bname:dword	; user wants to see the output
	local MyBuf[260]:byte
	inv ShellExecute, 0,0,bname,0,0, SW_SHOWNORMAL
	cmp	eax,33
	jb	@f
	ret
@@:
	.if eax== SE_ERR_NOASSOC
		lea edi,MyBuf
		mov esi,soff("rundll32.exe shell32.dll,OpenAs_RunDLL ")
		mov ecx,39
		rep movsb
		mov esi,bname
		@@:
		lodsb
		stosb
		cmp al,0
		jne @b
		msg MyBuf
		inv WinExec,addr MyBuf,SW_SHOWNORMAL
	.elseif eax==0  ;ERROR_OUT_OF_MEM:
    	msg "Out of Memory/Resources"
	.elseif eax==ERROR_FILE_NOT_FOUND
    	msg "File not found"
	.elseif eax==ERROR_PATH_NOT_FOUND
    	msg "Path not found"
	.elseif eax==ERROR_BAD_FORMAT
    	msg "Bad File Format"
	.endif
	ret
ShowFile EndP

CheckStringsFileName proc	; check the name of the file the user wants to save strings in
	inv SendMessage,hStringsFile,WM_GETTEXT,260,addr Buff
	or	eax,eax
	jz	ofileerror
	inv	GetFullPathName,addr Buff,260,addr Buff2,addr tmp ; Get real full name of result file
	or	eax,eax
	jz	ofileerror
	clc
	ret
ofileerror:
	call BadStringsFileName
	stc
	ret
CheckStringsFileName EndP

BadStringsFileName proc
	msg "Please enter valid file name"
	inv SetFocus,hStringsFile
	ret
BadStringsFileName EndP

WriteString proc hand:dword,sbuf:dword  ; write out the users search strings to his preferred file name
	mov eax,sbuf
	.repeat
	inc eax
	.until byte ptr[eax-1]==0
	sub eax,sbuf	; size
	dec eax 
	inv WriteFile,hand,sbuf,eax,addr junk,0	
	ret
WriteString EndP

SaveStringsClick proc	; user wants to save his search strings in a file
	pusha
	inv	CheckStringsFileName
	.if Carry?
		jmp SaveStringsRet
	.endif
	mov tmp,0
	inv CreateFile,addr Buff2,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	.if eax==INVALID_HANDLE_VALUE
		inv GetErrDescriptionx,soff("SaveStrings")
		call BadStringsFileName
		jmp SaveStringsRet
	.endif
	mov tmp,eax

	m2m	ETextx,hEText1	; do search strings first
	inv WriteString,tmp,soff("-Strs:",13,10,0)
@@:
	inv SendMessage,ETextx,WM_GETTEXT,OutputBufSize,OutputBuf
	mov edx,eax
	add edx,OutputBuf
	.if word ptr [edx-2] != 0A0Dh
		mov word ptr [edx],0A0Dh
		add eax,2
	.endif
	inv WriteFile,tmp,OutputBuf,eax,addr junk,0
	mov eax,hEText2
	cmp eax,ETextx
	je	@f	; all done
	mov ETextx,eax
	inv WriteString,tmp,soff("-Nots:",13,10,0)
	jmp @b
@@:


SaveStringsRet:	
	.if tmp!=0
		inv CloseHandle,tmp
	.endif
	popa
	ret
SaveStringsClick EndP

ReadStringsClick proc	; user want to read search strings from a previously saved file
	pusha
	inv	CheckStringsFileName
	.if Carry?
		jmp ReadStringsRet
	.endif
	mov tmp,0
	inv CreateFile,addr Buff2,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	.if eax==INVALID_HANDLE_VALUE
		inv GetErrDescriptionx,soff("ReadStrings")
		call BadStringsFileName
		jmp ReadStringsRet
	.endif
	mov tmp,eax
	inv ReadFile,tmp,OutputBuf,OutputBufSize,addr junk,0
	mov ecx,junk
	cmp ecx,8
	jbe ReadStringsRet
	mov esi,OutputBuf
	mov byte ptr[esi+ecx],0
	cmp dword ptr[esi],"rtS-"
	jne	BadFile
	cmp dword ptr[esi+4],0A0D3A73h  ; "s:",13,10
	jne BadFile
	add esi,8
	sub ecx,8
	mov edx,esi	; save start
xx1:
	cmp dword ptr[esi],"toN-"
	jne xx2
	cmp dword ptr[esi+4],0A0D3A73h   ; "s:,13,10
	jne xx2
	mov byte ptr [esi],0
	inv SendMessage,hEText1,WM_SETTEXT,0,edx
	add esi,8
	inv SendMessage,hEText2,WM_SETTEXT,0,esi
	jmp ReadStringsRet
xx2:
	lodsb
	dec	ecx
	jz DoneStrs
	cmp al,10
	jne xx2
	jmp	xx1
DoneStrs:
	inv SendMessage,hEText1,WM_SETTEXT,0,edx

BadFile:
	msg "No Strings"		

ReadStringsRet:	
	.if tmp!=0
		inv CloseHandle,tmp
	.endif
	popa
	ret
ReadStringsClick EndP

EditFile proc	; user wants to see the results
call SetupOutputFileName
jc	@f
inv ShowFile,offset ResultFile
@@:
ret
EditFile EndP


.data
DoingFiles dd 0
.code

SetupGetNextFile proc
	mov Phase,0		; initialize process
	ret
SetupGetNextFile EndP

GetNextFile proc  ; assumes FileN contains full path to folder wanted,
	cmp Phase,0
	jne iloop		; everything is set up, just continue	
	mov ecx,offset FileN
	cmp byte ptr [ecx],0	
	jz cleanup		; user forgot to set starting path
	mov Phase,1
	.repeat			; find end of folder name
		inc ecx
	.until byte ptr [ecx]==0
	mov LastFilePtr,ecx
    mov eax,offset Folders
    mov pnt,eax		; start with first one
    mov	Level,1	   ; start at first level

ReStart:
    mov DoingFiles,1
ReStart2:
	mov eax,LastFilePtr
	cmp byte ptr [eax-1],'\'	; add trailing slash if needed
	je 	HaveSlash
	mov word ptr [eax],005Ch	; backslash plus zero byte terminator
	inc eax
	mov LastFilePtr,eax			; save pointer to end of string for this level
HaveSlash:
	mov ecx,pnt
	mov [ecx],eax				; save for going deeper into folders
	mov dword ptr [eax],002A2E2Ah	; set "*.*" search pattern, including zero byte terminator
	;inv MessageBox,0,addr FileN,0,MB_OKCANCEL   ; debug stuff
	;cmp eax,IDCANCEL
	;je	cleanup
    inv FindFirstFile,offset FileN,ADDR wfd
    mov SearchHandle,eax		; save search handle for this level
    mov ecx,pnt
    mov [ecx+4],eax				; save SearchHandle for going deeper into folders
    cmp eax,INVALID_HANDLE_VALUE  ; (-1)
    je	continue				; out of files, go move up or quit
	jmp @f						; already have one, skip over findnext

iloop:
	inv FindNextFile, SearchHandle,ADDR wfd
    or 	eax,eax
    jz 	CloseSearchHandle	; out of files in this folder
@@:
    mov edx,offset wfd.cFileName
    cmp byte ptr [edx],'.'	; discard current and parent directory
    je 	iloop
  	mov ecx,LastFilePtr		; still have address of wfd.cFileName in edx
@@:
	mov al,byte ptr [edx]	; tack new file or folder name onto current folder
	mov byte ptr [ecx],al
	inc edx
	inc ecx
	or 	al,al
	jnz	@b
    test wfd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY	; was it a new folder?
    jnz	DoNewFolder			; go do files in new folder
    cmp DoingFiles,1
    jne iloop	; not doing files, get next
    ret		; return next file name.  (carry flag was set to zero by test instruction)

DoNewFolder:
	cmp DoingFiles,2
	jne	iloop
	mov eax,Level
	cmp eax,MaxLevel	; max of 128 levels deep
	je	iloop			;  can't be more than 128 in valid 260 character path, i.e.
	dec ecx				;    I can't feed a path that long to FindFirstFile api
  	mov LastFilePtr,ecx	; save new end of name pointer
  	add pnt,8			; next LastFilePtr,SearchHandle location
	inc Level			; keep track of how deep we are into subfolders
	jmp ReStart			; go get all the files in this new folder
	
CloseSearchHandle:
	inv FindClose,SearchHandle	; done with this search handle, close it
	cmp	DoingFiles,1
	jne	continue		; all done
	mov	DoingFiles,2	; time to do the folders
	jmp ReStart2
continue:
	dec	Level	; are we done
	jnz	@f
cleanup:
	mov Phase,0
	stc			; flag all done
	ret
@@:
	sub pnt,8	; back to previous set
	mov ecx,pnt
	mov eax,[ecx]	; get previous end of string pointer (LastFilePtr)
	mov LastFilePtr,eax ; back to where we started
	mov eax,[ecx+4]		; get previous searchhandle
	mov SearchHandle,eax
	mov DoingFiles,2	; has to be folders at this point, should have already done all the files
    jmp iloop

GetNextFile endp


;-------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------------------
;--------------------------- browse for folder and file code ------------------------------------------
;-------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------------------

;---------   SHBrowseForFolder stuff --------------------

;  note***  I had to subclass this turkey in order to set it's position.  Otherwise,
;           a bug in shbrowseforfolder would remember the last size used, but position
;           the dialog in a centered location so that the bottom would be off the screen.
.data?
hShBrowse dd ?
OldShProc dd ?
EditBoxHandle dd ?
bi BROWSEINFO <?>
.code
SHBrowseDialogProc proc hShDiag:DWord,uMsg:DWord,wParam:DWord,lParam:DWord
	.if uMsg==WM_EXITSIZEMOVE
		inv GetWindowRect,hShBrowse,addr SHSave		; save new postion for next time
	.elseif uMsg==WM_USER+200
		inv SetWindowPos,hShBrowse,0,SHSave.left,SHSave.top,0,0,SWP_NOSIZE or SWP_NOZORDER
	.endif
    inv CallWindowProc,OldShProc,hShBrowse,uMsg,wParam,lParam	; pass along to old handler
	ret
SHBrowseDialogProc EndP
SHBrowseForFolderCallBack proc hWnd:dword,uMsg:dword,lParam:dword,lpData:dword
	.if uMsg== BFFM_INITIALIZED ; 1=initialized, 2=selchanged, 5=IUNKNOWN
		mov eax,hWnd
		mov hShBrowse,eax
		inv SetWindowLong,eax,GWL_WNDPROC,offset SHBrowseDialogProc	; subclass the dialog to get position info
		mov OldShProc,eax
		inv PostMessage,hShBrowse,WM_USER+200,0,0 ; set position when stable
	    inv FindFirstFile,lpData,ADDR wfd
		inv FindClose, eax   ;found
		mov edx,lpData
		inv SendMessage,hShBrowse,BFFM_SETSELECTION,1,edx ; set the starting folder
	.endif
	ret
SHBrowseForFolderCallBack EndP

GetFolder proc	; assumes ecx=handle to control that contains starting folder and will get new folder
	mov EditBoxHandle,ecx
	inv SendMessage,ecx,WM_GETTEXT,512,offset Buff
	m2m bi.hwndOwner,hWin ; just to make it modal and to keep two instances from popping up
	m2m bi.ulFlags,BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN or BIF_NEWDIALOGSTYLE
	mov bi.lpfn,offset SHBrowseForFolderCallBack
	m2m bi.lParam,offset Buff
    inv SHBrowseForFolder,ADDR bi
    .if eax
	    push eax	; save pointer
    	inv SHGetPathFromIDList,eax,offset Buff
		.if eax
			inv SetWindowText,EditBoxHandle,offset Buff
	    .endif
		pop eax
	    inv CoTaskMemFree,eax
	.endif
	ret
GetFolder EndP

.data
maxf equ MAX_PATH+4
Filt db " ",0,"*.*",0,0
ext  db 4 dup (0)
TitNam db maxf dup (0)
ofn OPENFILENAME <sizeof OPENFILENAME, \
 0, \	;hwndOwner
 0, \	;hInstance
 offset Filt,\ ;lpstrFilter
 0, \	;lpstrCustomFilter
 0, \	;nMaxCustFilter
 0, \	;nFilterIndex
 offset Buff,\ ;lpstrFile
 maxf,\ ;nMaxFile
 offset TitNam,\ ;lpstrFileTitle
 maxf,\ ;nMaxFileTitle
 0, \	;lpstrInitialDir
 0, \	;lpstrTitle
 0, \	;Flags
 0, \	;nFileOffset (WORD)
 0, \	;nFileExtension (WORD)
 offset ext,\ ;lpstrDefExt
 0, \	;lCustData
 0, \	;lpfnHook
 0>  	;lpTemplateName

ofnparent dd 0
Oldofn dd 0

.code
GetFileName proc
	mov EditBoxHandle,ecx
	inv SendMessage,ecx,WM_GETTEXT,512,offset Buff
	m2m ofn.hWndOwner,hWin
	
	OFN_ENABLESIZING equ 800000h
	mov ofn.Flags,OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_EXPLORER or OFN_ENABLESIZING
	mov ofn.lpstrInitialDir,offset Buff
	mov ofn.nMaxFile,maxf
	mov TitNam,0
	inv GetOpenFileName,addr ofn
	inv SetWindowText,EditBoxHandle,addr Buff
	ret
GetFileName EndP


;-------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------------------
;------------------------- control positioning and sizing routines ------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------------------

ControlData Struc  ; handle, original positions, how to change code.
   I dd ? ; ID
   h dd ? ; handle
   L dd ? ; Left
   T dd ? ; Top
   W dd ? ; Width
   H dd ? ; Height
   Q dd ? ; change code (what changes and how)
   S dd ? ; Spare
ControlData Ends

.code
GetAllPostionsAndHandles proc  ; routine used only once
	pusha
	inv GetClientRect,hWin,addr OrigLoc  ;get the size of dialog client area
	mov eax,NumberOfControls
	inv HeapAlloc,HeapHandle,HEAP_ZERO_MEMORY,NumberOfControls * sizeof ControlData
	.if eax==0
		inv ShowHeapError,soff("FormLoad2")
		jmp ErrorRet
	.endif
	mov Ctrls,eax
	mov ebx,StartOfHandles		; first one of the group
	mov edi,Ctrls
	mov esi,StartOfBitCodes
	pdata equ [edi].ControlData  ; set data pointer to start of block
	.repeat
		mov ecx,[ebx]	; get id
		mov pdata.I,ecx
	    inv GetDlgItem,hWin,ecx	; handles start out life equal to the id and are changed here
	    mov [ebx],eax	; save handle
	    mov pdata.h,eax
	    lea ecx,pdata.L
		inv GetWindowRect,pdata.h,ecx	; get the position and size
	    lea ecx,pdata.L
		inv MapWindowPoints,0,hWin,ecx,2	; convert to something MoveWindow likes
		mov eax,pdata.T
		sub pdata.H,eax ;compute height
		mov eax,pdata.L
		sub pdata.W,eax	;compute width
		movzx eax,byte ptr [esi]	; get bit change code
		mov pdata.Q,eax
		inc esi
		add edi,sizeof ControlData
		add ebx,4
	.until ebx==LastHandle
	mov LastCtrl,edi		; save end of control memory for later tests
	jmp GoodRet

ErrorRet:
	stc
	jmp GetPosRet
	
GoodRet:
	clc
GetPosRet:
	popa
    ret
GetAllPostionsAndHandles EndP

FormResize proc
local wdelta:dword,hdelta:dword,w2delta:dword,h2delta:dword,NewCon:Loca

;Code bit   action
; L    0 000001b set left based upon dia width
; T    1 000010b set top  based upon dia height
; T2   2 000100b set top based upon 1/2 dia height e.g. rich edits, rich2 label
; H2   3 001000b set Height based upon 1/2 dia height e.g. rich edits
; W    4 010000b set width based upon dia width
; L2   5 100000b set left based upon 1/2 dia width  eg. search, edit buttons, bottom info

	pusha
    cmp RunningFlag,1
    jne FormResizeReturn
	mov eax,OrigLoc.H
	sub eax,NewHeight
	mov hdelta,eax
	sar eax,1
	mov h2delta,eax
	mov eax,OrigLoc.W
	sub eax,NewWidth
	mov wdelta,eax
	sar eax,1
	mov w2delta,eax
		
	mov esi,Ctrls
	pdata equ [esi].ControlData  ; how to get to data using esi as base register
	.repeat
		mov eax,pdata.L		; copy to temp location
		mov NewCon.L,eax
		mov eax,pdata.T
		mov NewCon.T,eax
		mov eax,pdata.W
		mov NewCon.W,eax
		mov eax,pdata.H
		mov NewCon.H,eax
		mov ecx,pdata.Q
		
		.if ecx & 000001b	;  set new left
			mov eax,wdelta
			sub NewCon.L,eax
		.endif
		.if ecx & 010000b	; set new width
			mov eax,wdelta
			sub NewCon.W,eax
		.endif
		.if ecx & 000010b	; set new top
			mov eax,hdelta
			sub NewCon.T,eax
		.endif		
		.if ecx & 000100b	; set new top=1/2 delta
			mov eax,h2delta
			sub NewCon.T,eax
		.endif
		.if ecx & 001000b	; set new height=1/2 delta
			mov eax,h2delta
			sub NewCon.H,eax
		.endif
		.if ecx & 100000b	; set new left=1/2 delta
			mov eax,w2delta
			sub NewCon.L,eax
		.endif
		inv MoveWindow,pdata.h,NewCon.L,NewCon.T,NewCon.W,NewCon.H,TRUE
		add esi,sizeof ControlData
	.until esi==LastCtrl ;
FormResizeReturn:
	popa
    ret
FormResize Endp


;-------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------------------
;--------------------------------- File spec editing ---------------------------------------------------
;-------------------------------------------------------------------------------------------------------

SetupFileSpecEdit proc  ; user want to put in some prefered file specifications
	pusha	; not time critical
	mov DoingFSEdit,1
	inv SendMessage,hSearch,WM_SETTEXT,0,soff("Save")
	inv SendMessage,hEditOutput,WM_SETTEXT,0,soff("Cancel")
	call DisableAllHandles
	inv EnableWindow,hSearch,TRUE
	inv EnableWindow,hEditOutput,TRUE
	inv EnableWindow,hEText2,TRUE
	inv GetDlgItemText,hWin,Rich2Label,addr Buff,512
	inv SetDlgItemText,hWin,Rich2Label,soff("Editing File Specifications")
	call SaveCurrentFileSpec
	ob14 equ OutputBufSize/4
	ob12 equ 2*ob14
	ob34 equ 3*ob14
	mov esi,OutputBuf
	add esi,ob34
	inv SendMessage,hEText2,WM_GETTEXT,ob14,esi	; save current strings if any
	mov esi,OutputBuf
	add esi,ob12		; scratch for copying combo box info
	inv GetPrivateProfileSection,addr FileTypesOption,esi,ob12,addr IniName
	push esi
	.repeat
		.repeat
			lodsb
		.until al==0
		mov byte ptr[esi-1],10
		mov al,byte ptr[esi]
	.until al==0
	pop esi	
	inv SendMessage,hEText2,WM_SETTEXT,0,esi
	inv SetFocus,hEText2
	popa
	ret
SetupFileSpecEdit EndP

SaveFileSpecEdit proc
	pusha
	mov esi,OutputBuf
	add esi,ob12
	inv SendMessage,hEText2,WM_GETTEXT,ob12,esi
	inv WritePrivateProfileSection,addr FileTypesOption,0,addr IniName	; erase previous
	inv WritePrivateProfileSection,addr FileTypesOption,esi,addr IniName
	call SetupFileTypesCombo
	call CancelFileSpecEdit	; go cleanup
	popa
	ret
SaveFileSpecEdit EndP

CancelFileSpecEdit proc
	pusha
	mov esi,OutputBuf
	add esi,ob34
	inv SetDlgItemText,hWin,EText2,esi
	inv SendMessage,hSearch,WM_SETTEXT,0,addr SearchName
	inv SendMessage,hEditOutput,WM_SETTEXT,0,addr EditName
	inv SetDlgItemText,hWin,Rich2Label,addr Buff
	call EnableAllHandles
	mov DoingFSEdit,0
	popa
	ret
CancelFileSpecEdit EndP

; ---------------  miscellaneous routines -------------------------

align 4

dwtoax2 proc	; adapted from what masm32 lib's dwtoa
  ; convert eax, save at address in edi, return with edi pointing to zero byte terminator
			; also saves ALL registers (except edi which is updated) 
    or eax,eax		; test for zero and negative values
    .if Zero?
	    mov word ptr [edi],30h  ; "0" and zero byte terminator
    	inc edi		; point at terminator
		ret
 	.endif
    push esi
    push ecx
    push edx
    push ebx
	.if Sign?    
	    mov byte ptr [edi],'-'
    	neg eax
    	add edi, 1
    .endif
    mov ecx, 0CCCCCCCDh	; 8 * 1/10
    mov esi, edi	; save start of string
	.Repeat
		mov ebx,eax
		mul ecx
		shr edx, 3
		mov eax,edx
		lea edx,[edx*4+edx]
		add edx,edx
		sub ebx,edx
		add bl,'0'
		mov [edi],bl
		add edi, 1
	.Until eax==0
    mov byte ptr [edi], 0   ; terminate the string
    mov ecx,edi
    .repeat 		    	; We now have all the digits, but in reverse order.
      sub ecx, 1			; swap as needed
      mov al, [esi]
      mov ah, [ecx]
      mov [ecx], al
      mov [esi], ah
      add esi, 1
    .until (esi >= ecx)
    pop ebx
    pop edx
    pop ecx
	pop esi
    ret
dwtoax2 endp

;  Adapted from atol in m32lib
ReadLong proc uses ebx ecx  ;, AsciiStringIn:DWORD edx is first char, return val in eax, edx=next char
; convert ascii string with optional sign as first non-blank character to dword. Stop on invalid character

	xor ebx,ebx			; sign, assume positive
	xor ecx,ecx			; where we will build number
	xor eax,eax
@@:
	mov al,[edx]		; get character to test
	inc edx				; set up for next character
	cmp al,32			; discard leading blanks and tabs
	je @b
	cmp al,9
	je @b
	cmp al,'+'
	je nxt				; ignore
	cmp al,'-'			; check for minus sign
	jne nosign			; wasn't a sign, use this character
	not ebx				; set sign flag negative
nxt:
	mov al,[edx]
	inc edx
nosign:
	sub al,"0"		
	jc  @F
	cmp al,9
	ja	@f
	lea ecx,[ecx+ecx*4]	; old * 5
	lea ecx,[eax+ecx*2]	; new + old * 10
	jmp nxt
@@:
	mov eax,ecx
	or ebx,ebx			; test sign
	jz @F
	neg eax
@@:
    ret
ReadLong endp

end Program